/*
 *
 * VMMZ: Delta Encoding of Virtual-Machine Memory
 * Copyright (C) 2015-2016  James E. Fowler
 *
 * This file is a part of VMMZ.
 *
 * VMMZ is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with VMMZ; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#ifndef VMMZ_H
#define VMMZ_H

#include "xdelta3.h"
#include "libQccPack.h"

#define VMMZ_MAGICNUM "VMMZ"
#define VMMZ_MAJORVERSION 1
#define VMMZ_MINORVERSION 0
#define VMMZ_DATE "15-mar-2016"
#define VMMZ_COPYRIGHT "Copyright (C) 2015-2016 James E. Fowler"

#define VMMZ_ENCODED_OUTFILESIZE 0.25

void VMMZSetHeader(void);
int VMMZDiff(const QccString filename1,
             const QccString filename2,
             long *filesize,
             long *num_differences,
             QccIMGImage *output_image);
int VMMZEncode(const QccString baseline_filename,
               const QccString current_vmem_filename,
               const QccString outfile_filename,
               const QccString vmdk_filename,
               const QccString volatility_profile,
               long *baseline_filesize,
               const QccString predicted_vmem_filename);
int VMMZDecode(const QccString baseline_filename,
               const QccString vmdk_filename,
               const QccString infile_filename,
               const QccString output_vmem_filename);

#include "vmmz_pe.h"
#include "vmmz_vmdk.h"

#endif /* VMMZ_H */
