/*
 *
 * VMMZ: Delta Encoding of Virtual-Machine Memory
 * Copyright (C) 2015-2016  James E. Fowler
 *
 * This file is a part of VMMZ.
 *
 * VMMZ is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with VMMZ; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#ifndef VMMZ_COPYFILE_H
#define VMMZ_COPYFILE_H

#include "libQccPack.h"


typedef struct
{
  unsigned int source;
  unsigned int destination;
  unsigned int length;
} VMMZCopyEntry;

#define VMMZ_COPYFILE_REALLOC_SIZE 500
typedef struct
{
  QccString filename;
  int num_copies;
  int num_allocated_copies;
  VMMZCopyEntry *copies;
} VMMZCopyFile;


void VMMZCopyFileInitialize(VMMZCopyFile *copy_file);
void VMMZCopyFileFree(VMMZCopyFile *copy_file);
int VMMZCopyFileAddCopy(VMMZCopyFile *copy_file,
                        const VMMZCopyEntry *copy);
int VMMZCopyFileInsert(unsigned char *memory,
                       long memory_size,
                       VMMZCopyFile *copy_file,
                       const QccString mount_point);


#endif /* VMMZ_COPYFILE_H */
