/*
 *
 * VMMZ: Delta Encoding of Virtual-Machine Memory
 * Copyright (C) 2015-2016  James E. Fowler
 *
 * This file is a part of VMMZ.
 *
 * VMMZ is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with VMMZ; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#ifndef VMMZ_COPYTABLE_H
#define VMMZ_COPYTABLE_H

#include "libQccPack.h"
#include "vmmz_copyfile.h"

typedef struct
{
  int num_files;
  VMMZCopyFile *files;
} VMMZCopyTable;


void VMMZCopyTableInitialize(VMMZCopyTable *copy_table);
int VMMZCopyTableAlloc(VMMZCopyTable *copy_table);
void VMMZCopyTableFree(VMMZCopyTable *copy_table);
int VMMZWriteCopyTable(FILE *outfile,
                       const VMMZCopyTable *copy_table);
int VMMZReadCopyTable(FILE *infile,
                      VMMZCopyTable *copy_table);
int VMMZCopyTableInsert(unsigned char *memory,
                        long memory_size,
                        VMMZCopyTable *copy_table,
                        const QccString mount_point);


#endif /* VMMZ_COPYTABLE_H */
