/*
 *
 * VMMZ: Delta Encoding of Virtual-Machine Memory
 * Copyright (C) 2015-2016  James E. Fowler
 *
 * This file is a part of VMMZ.
 *
 * VMMZ is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with VMMZ; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#include "vmmz.h"


void VMMZPageTableInitialize(VMMZPageTable *page_table)
{
  if (page_table != NULL)
    {
      page_table->pid = 0;
      page_table->length = 0;
      page_table->page_table = NULL;
    }
}


int VMMZPageTableAlloc(VMMZPageTable *page_table)
{
  if (page_table != NULL)
    if (page_table->length > 0)
      if ((page_table->page_table =
           (VMMZPageTableEntry *)malloc(sizeof(VMMZPageTableEntry) *
                                        page_table->length)) == NULL)
        {
          QccErrorAddMessage("(VMMZPageTableAlloc): Error allocating memory");
          return(1);
        }

  return(0);
}


void VMMZPageTableFree(VMMZPageTable *page_table)
{
  if (page_table != NULL)
    if (page_table->page_table != NULL)
      free(page_table->page_table);
}
