/*
 *
 * VMMZ: Delta Encoding of Virtual-Machine Memory
 * Copyright (C) 2015-2016  James E. Fowler
 *
 * This file is a part of VMMZ.
 *
 * VMMZ is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with VMMZ; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#ifndef VMMZ_PAGETABLE_H
#define VMMZ_PAGETABLE_H

#include "libQccPack.h"


typedef struct
{
  unsigned int virtual_address;
  unsigned int physical_address;
  unsigned int page_size;
} VMMZPageTableEntry;

typedef struct
{
  unsigned int pid;
  unsigned int length;
  VMMZPageTableEntry *page_table;
} VMMZPageTable;


void VMMZPageTableInitialize(VMMZPageTable *page_table);
int VMMZPageTableAlloc(VMMZPageTable *page_table);
void VMMZPageTableFree(VMMZPageTable *page_table);


#endif /* VMMZ_PAGETABLE_H */
