/*
 *
 * VMMZ: Delta Encoding of Virtual-Machine Memory
 * Copyright (C) 2015-2016  James E. Fowler
 *
 * This file is a part of VMMZ.
 *
 * VMMZ is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with VMMZ; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#ifndef VMMZ_PE_DEFS_H
#define VMMZ_PE_DEFS_H

#define MIN_PAGE_SIZE 0x1000

#define OFFSET_PE_SIG 0x3c
#define OFFSET_PE 0x00000000
#define OFFSET_COFF OFFSET_PE + 4
#define OFFSET_MACHINE OFFSET_COFF
#define OFFSET_NUMSECTIONS OFFSET_COFF + 2
#define OFFSET_COFF_SIZEOFOPTIONALHEADER OFFSET_COFF + 16
#define OFFSET_OPTIONAL_HEADER OFFSET_COFF + 20
#define OFFSET_OPTIONAL_WINDOWS_HEADER OFFSET_OPTIONAL_HEADER + 28
#define OFFSET_OPTIONAL_WINDOWS_HEADER_IMAGEBASE OFFSET_OPTIONAL_WINDOWS_HEADER
#define OFFSET_SIZEOFHEADERS OFFSET_OPTIONAL_HEADER + 60
#define OFFSET_DATA_DIRECTORIES OFFSET_OPTIONAL_HEADER + 96
#define OFFSET_BASE_RELOCATION_TABLE_ADDRESS OFFSET_OPTIONAL_HEADER + 136
#define OFFSET_BASE_RELOCATION_TABLE_SIZE OFFSET_OPTIONAL_HEADER + 140
#define OFFSET_SECTION_VIRTUALSIZE 8
#define OFFSET_SECTION_VIRTUALADDRESS 12
#define OFFSET_SECTION_RAWSIZE 16
#define OFFSET_SECTION_RAWPTR 20
#define SECTION_SIZE 40

#define GET_BASE_RELOCATION_TYPE(X) ((GET_UINT16(X) & 0xf000) >> 12)
#define GET_BASE_RELOCATION_OFFSET(X) (GET_UINT16(X) & 0x0fff)
#define IMAGE_REL_BASED_ABSOLUTE 0
#define IMAGE_REL_BASED_HIGHLOW 3

#define IMAGE_FILE_MACHINE_I386 0x14c

#define GET_UINT16(X) (*(uint16_t *)(&(X)))
#define GET_UINT32(X) (*(uint32_t *)(&(X)))

#endif /* VMMZ_PE_DEFS_H */
