/*
 *
 * VMMZ: Delta Encoding of Virtual-Machine Memory
 * Copyright (C) 2015-2016  James E. Fowler
 *
 * This file is a part of VMMZ.
 *
 * VMMZ is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with VMMZ; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#ifndef VMMZ_PEIMAGE_H
#define VMMZ_PEIMAGE_H

#include "libQccPack.h"

typedef struct
{
  long size;
  unsigned char *image;
} VMMZPEImage;


int VMMZGetPhysicalAddress(unsigned int virtual_address,
                           unsigned int *physical_address,
                           unsigned int *page_size,
                           unsigned int *page_start,
                           const VMMZPageTable *process);
void VMMZPEImageInitialize(VMMZPEImage *pe_image);
int VMMZPEImageAlloc(VMMZPEImage *pe_image);
void VMMZPEImageFree(VMMZPEImage *pe_image);
int VMMZPEImageRead(const QccString filename,
                    VMMZPEImage *pe_image);
int VMMZPEImageToMemory(const VMMZPEImage *pe_image,
                        unsigned int base_address,
                        unsigned char *memory,
                        long memory_size,
                        const VMMZPageTable *page_table,
                        VMMZCopyFile *copy_file);


#endif /* VMMZ_PEIMAGE_H */
