/*
 *
 * VMMZ: Delta Encoding of Virtual-Machine Memory
 * Copyright (C) 2015-2016  James E. Fowler
 *
 * This file is a part of VMMZ.
 *
 * VMMZ is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with VMMZ; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#include "vmmz.h"


void VMMZPETableInitialize(VMMZPETable *pe_table)
{
  if (pe_table != NULL)
    {
      QccStringMakeNull(pe_table->mount_point);
      pe_table->pes = NULL;
      pe_table->num_pes = 0;
    }
}


int VMMZPETableAlloc(VMMZPETable *pe_table)
{
  if (pe_table != NULL)
    if (pe_table->num_pes > 0)
      if ((pe_table->pes =
           (VMMZPEEntry *)malloc(sizeof(VMMZPEEntry) *
                                 pe_table->num_pes)) == NULL)
        {
          QccErrorAddMessage("(VMMZPETableAlloc): Error allocating memory");
          return(1);
        }
  return(0);
}


void VMMZPETableFree(VMMZPETable *pe_table)
{
  if (pe_table != NULL)
    if (pe_table->pes != NULL)
      free(pe_table->pes);
}


