/*
 *
 * VMMZ: Delta Encoding of Virtual-Machine Memory
 * Copyright (C) 2015-2016  James E. Fowler
 *
 * This file is a part of VMMZ.
 *
 * VMMZ is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with VMMZ; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#ifndef VMMZ_PETABLE_H
#define VMMZ_PETABLE_H

#include "libQccPack.h"


typedef struct
{
  QccString filename;
  unsigned int pid;
  unsigned int base_address;
} VMMZPEEntry;

typedef struct
{
  QccString mount_point;
  int num_pes;
  VMMZPEEntry *pes;
} VMMZPETable;


void VMMZPETableInitialize(VMMZPETable *pe_table);
int VMMZPETableAlloc(VMMZPETable *pe_table);
void VMMZPETableFree(VMMZPETable *pe_table);


#endif /* VMMZ_PETABLE_H */
