/*
 *
 * VMMZ: Delta Encoding of Virtual-Machine Memory
 * Copyright (C) 2015-2016  James E. Fowler
 *
 * This file is a part of VMMZ.
 *
 * VMMZ is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with VMMZ; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */


#include "vmmzdecode.h"

#define USG_STRING "[-b %: %s:baseline_vmem] [-d %: %s:vmdk_file] %s:bitstream %s:output_vmem"

int BaselineSpecified = 0;
QccString BaselineFilename;
int VMDKSpecified = 0;
QccString VMDKFilename;
QccString InfileFilename;
QccString OutputMemoryFilename;

int main(int argc, char *argv[])
{
  QccInit(argc, argv);
  
  VMMZSetHeader();
  
  if (QccParseParameters(argc, argv,
                         USG_STRING,
                         &BaselineSpecified,
                         BaselineFilename,
                         &VMDKSpecified,
                         VMDKFilename,
                         InfileFilename,
                         OutputMemoryFilename))
    QccErrorExit();
  
  if (VMMZDecode(((BaselineSpecified) ? BaselineFilename : NULL),
                 ((VMDKSpecified) ? VMDKFilename : NULL),
                 InfileFilename,
                 OutputMemoryFilename))
    {
      QccErrorAddMessage("%s: Error calling VMMZDecode()",
                         argv[0]);
      QccErrorExit();
    }
  
  QccExit;
}
